/*!

 =========================================================
 * Paper Dashboard - v1.2.0
 =========================================================

 * Product Page: http://www.creative-tim.com/product/paper-dashboard
 * Copyright 2018 Creative Tim (http://www.creative-tim.com)
 * Licensed under MIT (https://github.com/creativetimofficial/paper-dashboard/blob/master/LICENSE.md)

 =========================================================

 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

 */


var fixedTop = false;
var transparent = true;
var navbar_initialized = false;
var mobile_menu_initialized = false;

$(document).ready(function(){
    window_width = $(window).width();

    // Init navigation toggle for small screens
    if(window_width <= 991){
        pd.initRightMenu();
    }

    //  Activate the tooltips
    $('[rel="tooltip"]').tooltip();

});

$(document).on('click', '.navbar-toggle', function(){
  $toggle = $(this);
  if(pd.misc.navbar_menu_visible == 1) {
    $('html').removeClass('nav-open');
    pd.misc.navbar_menu_visible = 0;
    $('#bodyClick').remove();
    setTimeout(function(){
      $toggle.removeClass('toggled');
    }, 400);
  } else {
    setTimeout(function(){
      $toggle.addClass('toggled');
    }, 430);

    div = '<div id="bodyClick"></div>';
    $(div).appendTo("body").click(function() {
      $('html').removeClass('nav-open');
      pd.misc.navbar_menu_visible = 0;
      $('#bodyClick').remove();
      setTimeout(function(){
        $toggle.removeClass('toggled');
      }, 400);
    });

    $('html').addClass('nav-open');
    pd.misc.navbar_menu_visible = 1;
  }
});

// activate collapse right menu when the windows is resized
$(window).resize(function(){
    if($(window).width() <= 991){
        pd.initRightMenu();
    }
});

pd = {
    misc:{
        navbar_menu_visible: 0
    },
    checkScrollForTransparentNavbar: debounce(function() {
        if($(document).scrollTop() > 381 ) {
            if(transparent) {
                transparent = false;
                $('.navbar-color-on-scroll').removeClass('navbar-transparent');
                $('.navbar-title').removeClass('hidden');
            }
        } else {
            if( !transparent ) {
                transparent = true;
                $('.navbar-color-on-scroll').addClass('navbar-transparent');
                $('.navbar-title').addClass('hidden');
            }
        }
    }),
    initRightMenu: debounce(function() {
        var $sidebar_wrapper = $('.sidebar-wrapper');
        var $sidebar = $('.sidebar');

        if (!mobile_menu_initialized) {
            var $navbar = $('nav').find('.navbar-collapse').children('.navbar-nav');

            mobile_menu_content = '';

            nav_content = $navbar.html();

            //nav_content = '<ul class="nav nav-mobile-menu">' + nav_content + '</ul>';

            $sidebar_nav = $sidebar_wrapper.find(' > .nav');

            // insert the navbar form before the sidebar list
            $sidebar.addClass('off-canvas-sidebar');
            $nav_content = $(nav_content);
            $nav_content.insertBefore($sidebar_nav);

            $(".sidebar-wrapper .dropdown .dropdown-menu > li > a").click(function(event) {
                event.stopPropagation();

            });

            // simulate resize so all the charts/maps will be redrawn
            window.dispatchEvent(new Event('resize'));

            mobile_menu_initialized = true;
        } else {
            if ($(window).width() > 991) {
                // reset all the additions that we made for the sidebar wrapper only if the screen is bigger than 991px
                $sidebar_wrapper.find('.nav-mobile-menu').remove();
                $sidebar.removeClass('off-canvas-sidebar');

                mobile_menu_initialized = false;
            }
        }
    }, 200)
}


// Returns a function, that, as long as it continues to be invoked, will not
// be triggered. The function will be called after it stops being called for
// N milliseconds. If `immediate` is passed, trigger the function on the
// leading edge, instead of the trailing.

function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
};



	//--------------------------------------------------------------------
	function _(p){return document.getElementById(p);};
	//Status - footer
	function _status(id,msg){var d = new Date();_(id).innerHTML='<i class="ti-reload" ></i> '+msg+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')';}
	var syscon_cnt=0;
	function _status_connect(){syscon_cnt++;syscon_cnt=syscon_cnt%3;var temp=syscon_cnt==0?'.':syscon_cnt==1?'..':syscon_cnt==2?'...':'.';var d = new Date();_('StatConnect').innerHTML='Synced'+temp+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')';}
	//Status - notify
	var noti_types=['info','success','warning','danger'];
	function _noti(type,msg){var d = new Date();$(document).ready(function(){$.notify({message: '- '+msg+' ('+d.getFullYear()+'-'+ (d.getMonth()+1)+'-'+ d.getDate()+' '+ d.getHours()+':'+ d.getMinutes()+':'+ d.getSeconds()+')'},{type: noti_types[type],timer: 1000});});}


	//tooltip
	$(document).ready(function(){
	  $('[data-toggle="tooltip"]').tooltip(); 
	});
		
	function SetLed(el,val){
		//Remove class
		if (document.getElementById(el).classList.contains('text-muted')){
			document.getElementById(el).classList.remove('text-muted');
		}else if(document.getElementById(el).classList.contains('text-success')){
			document.getElementById(el).classList.remove('text-success');
		}else if(document.getElementById(el).classList.contains('text-warning')){
			document.getElementById(el).classList.remove('text-warning');
		}
		//Set class
		if(val=='1'){
			document.getElementById(el).classList.add('text-success');
		}else if(val=='2'){
			document.getElementById(el).classList.add('text-warning');
		}else{
			document.getElementById(el).classList.add('text-muted');
		}
	}
	
	//--------------------------------------------------------------------
	function ResetJogActive(el){
		//Remove class
		if (document.getElementById(el).classList.contains('jog-active')){
			document.getElementById(el).classList.remove('jog-active');
		}
	}
	
	function SetJogActive(target,els){
		//Remove class
		ResetJogActive(els[0]);
		ResetJogActive(els[1]);
		ResetJogActive(els[2]);
		ResetJogActive(els[3]);
		//Set class
		if(target=='1'){
			document.getElementById(els[0]).classList.add('jog-active');
		}else if(target=='2'){
			document.getElementById(els[1]).classList.add('jog-active');
		}else if(target=='3'){
			document.getElementById(els[2]).classList.add('jog-active');
		}else if(target=='4'){
			document.getElementById(els[3]).classList.add('jog-active');
		}
	}

	
	
	//--------------------------------------------------------------------
	//Error
	var GcsError=[
		/*00*/ "No Error",
		/*01*/ "Reserved",
		/*02*/ "02) Can't find PCU(Antenna)",
		/*03*/ "Reserved",
		/*04*/ "Reserved",
		/*05*/ "Reserved",
		/*06*/ "Reserved",
		/*07*/ "Reserved",
		/*08*/ "08) MNC port restarting",
		/*09*/ "09) ABS port restarting",
		/*10*/ "10) TTP port restarting",
		/*11*/ "Reserved",
		/*12*/ "Reserved",
		/*13*/ "Reserved",
		/*14*/ "Reserved",
		/*15*/ "Reserved",
		/*16*/ "Reserved",
		/*17*/ "Reserved",
		/*18*/ "Reserved",
		/*19*/ "Reserved",
		/*20*/ "Reserved",
		/*21*/ "Reserved",
		/*22*/ "Reserved",
		/*23*/ "Reserved",
		/*24*/ "24) Activated FakeGPS mode",
		/*25*/ "Reserved",
		/*26*/ "Reserved",
		/*27*/ "Reserved",
		/*28*/ "Reserved",
		/*29*/ "Reserved",
		/*30*/ "Reserved",
		/*31*/ "Reserved"
	];
	
	//Gcs
	
	var CmdList = [,];
	function SetUILed(obj)
	{
		SetLed("ledGcsRun",obj.GCS.Run);
		SetLed("ledGcsTx",obj.GCS.TX);
		SetLed("ledGcsLock",obj.GCS.Lock);
		SetLed("ledGilatRun",obj.Gilat.Run);
		SetLed("ledGilatLink",obj.Gilat.Link);
		SetLed("ledGilatTelnet",obj.Gilat.Telnet);
		SetLed("ledAcuRun",obj.ACU.Run);
		SetLed("ledAcuLink",obj.ACU.Link);
		SetLed("ledAcuGps",obj.ACU.GPS);
		SetLed("ledAcuTrk",obj.ACU.TRK);
	}
	
	function SetUIChart(data)
	{
		try{
			var list = {labels: [, ],series: [[, ],]};
			var i=0;
			while(true){
				if(data[i]==null) break;
				//console.log(data["d"+i].dB);
				i++;
			} 
			
			var j=0;
			while(j<i){
				var temp = data[j].Time.split(' ');
				var temp_time = temp[1].split(':');
				var temp_min_sec = temp_time[1]+':'+temp_time[2];
				var temp_sec = temp_time[2];
				list.labels[j]= (i<3)?temp:(i<6)?temp[1]:(j%(parseInt(i/9)+1))==0?temp_min_sec:"";
				list.series[0][j]=data[j].dB;
				j++;
			}
			if(i>10){
				list.labels[i-4]="";
				list.labels[i-3]="";
				var temp = data[i-i].Time.split(' ');
				var temp_min_sec = temp_time[1]+':'+temp_time[2]
				list.labels[i-2]=temp_min_sec;
				list.labels[i-1]="";
			}
			
			
			_("txtSNR").innerHTML="SNR  "+"<font style='color:#68b3c8' >("+data[(i-1)].dB+"dB)</font>";

			var options = {
				seriesBarDistance: 10,
				//showPoint: false,
				axisX: {
					showGrid: false,
				},
				height: "135px"
			};

			var responsiveOptions = [
			  ['screen and (max-width: 640px)', {
				seriesBarDistance: 5,
				axisX: {
				  labelInterpolationFnc: function (value) {
					return value[0];
				  }
				}
			  }]
			];
			

			Chartist.Line('#chartActivity', list, options, responsiveOptions);
		}catch(e){
			
			console.log(e);
			console.log(list);
			console.log(data);
		}
	}

	function DoWebEvent(){
		var cmd = null;
	
		if(CmdList.length > 0) cmd = CmdList.pop();
		
		if(cmd != null)
		{
			//console.log(cmd);
			var cmd_str = JSON.stringify(cmd);
		
			var xhp = new XMLHttpRequest();  
			//xhp.addEventListener("error", console.log("*DoWebEvent."));
			xhp.onreadystatechange = function() {  
			if (this.readyState == 4 && this.status == 200) {
				//_print(this.responseText);
				ProcRecv(this.responseText);	
			}};
			xhp.open("GET", "sock/request_java.php?req="+cmd_str, true);
			xhp.send();
		}
	}
	
	var StatusInterval = 0;
	function ReadGcsInformation(freq)
	{
		if(StatusInterval--==freq)
		{
			AppendWebEvent(0x0100);
		}
		StatusInterval=StatusInterval<=0?freq:StatusInterval;
	}
	
	
	
	function SetSessionBlock(obj)
	{
		//Session
		_('SessionBlock').style.display = obj.GCS.Run?'block':'none';
		var seesion_prog = parseInt((obj.DrivingInfo.SessionTime/obj.DrivingInfo.Interval)*100);
		var session_prog_msg = "";
		if(seesion_prog>100){
			seesion_prog = 100;
			session_prog_msg = "Locked";
		}else{
			session_prog_msg = seesion_prog + "%";
		}
		var temp = "Satellite No."+(obj.DrivingInfo.SessionIdx==0?"-":obj.DrivingInfo.SessionIdx)+" / "+obj.DrivingInfo.SessionNum + " ("+session_prog_msg+")";
		_('SessionInfo').innerHTML=temp;
		_('SessionInfoProgBar').value=seesion_prog;
		
		//Warnning Message
		var chk_con_msg ="";
		var warning = !(obj.Gilat.Link&obj.Gilat.Telnet&obj.ACU.Link);
		SetSessionBarStatus('SessionBlockBar', !warning);
		if(warning){
			if(!(obj.Gilat.Link&obj.Gilat.Telnet) && !obj.ACU.Link) chk_con_msg=" - *Checking connection(Gilat/ACU)";
			else if((obj.Gilat.Link&obj.Gilat.Telnet) && !obj.ACU.Link) chk_con_msg=" - *Checking connection(ACU)";
			else if(!(obj.Gilat.Link&obj.Gilat.Telnet) && obj.ACU.Link) chk_con_msg=" - *Checking connection(Gilat)";
			chk_con_msg = "<font style='color:#0a5f77;'>"+chk_con_msg+"</font>";
		}
		
		//Repeatition
		temp = "Repeatition "+ ((obj.DrivingInfo.RepetitionNum>0xFFFF)? "Unlimit":obj.DrivingInfo.CurrentSessionRepetitionNum+" / "+obj.DrivingInfo.RepetitionNum)+" "+ chk_con_msg;
		_('SessionInfo2').innerHTML=temp;
	}
	
	function SetSessionBarStatus(el,val){
		//Remove class
		if (document.getElementById(el).classList.contains('sb-warning')){
			document.getElementById(el).classList.remove('sb-warning');
		}
		//Set class
		if(val=='1'){
		}else{
			document.getElementById(el).classList.add('sb-warning');
		}
	}
	
	//
	//Cover - Loading 
	var ConnectionCnt = 0xFFFF;
	function ResetConnection(){ConnectionCnt=0;}
	function CheckConnection(idx){
		ConnectionCnt++;
		if(ConnectionCnt > idx){
			_('CoverLoading').style.display = 'block';
		}else{
			_('CoverLoading').style.display = 'none';
		}
	}
